<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/new_fortran_optimizer.gi.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>05/28/80  new_fortran optimizer
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>With the new_fortran <span class="textRainbow_lv0_p0">(</span>fortran<span class="textRainbow_lv0_o0">,</span> ft<span class="textRainbow_lv0_p0">)</span> command, the -optimize <span class="textRainbow_lv0_p0">(</span>-ot<span class="textRainbow_lv0_p0">)</span>
<span id="L4" class="LineNr">  4 </span>control argument invokes a loop optimizer and a machine dependant
<span id="L5" class="LineNr">  5 </span>global optimizer <span class="textRainbow_lv0_p0">(</span>register optimizer<span class="textRainbow_lv0_p0">)</span>.
<span id="L6" class="LineNr">  6 </span>
<span id="L7" class="LineNr">  7 </span>
<span id="L8" class="LineNr">  8 </span>Loop optimizer:
<span id="L9" class="LineNr">  9 </span>A loop optimizer is an optimizer that is cognizant of the flow of
<span id="L10" class="LineNr"> 10 </span>control in a program and uses that information to improve the code
<span id="L11" class="LineNr"> 11 </span>generated by the compiler.
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span>Examples of loop optimization:
<span id="L15" class="LineNr"> 15 </span>Calculations can be moved out of do-loops if the calculation is not
<span id="L16" class="LineNr"> 16 </span>dependent on the do-loop index.  Identical sub-expressions can be
<span id="L17" class="LineNr"> 17 </span>combined, and therefore only be calculated once, if the value of the
<span id="L18" class="LineNr"> 18 </span>sub-expression does not change in between its uses.  Whole assignment
<span id="L19" class="LineNr"> 19 </span>statements can be removed if the variable is assigned a new value
<span id="L20" class="LineNr"> 20 </span>before it is used.  Assignment statements can also be removed if they
<span id="L21" class="LineNr"> 21 </span>set automatic variables and are immediately followed by a return
<span id="L22" class="LineNr"> 22 </span>statement.
<span id="L23" class="LineNr"> 23 </span>
<span id="L24" class="LineNr"> 24 </span>
<span id="L25" class="LineNr"> 25 </span>This optimizer is considerably more powerful than the previous
<span id="L26" class="LineNr"> 26 </span>new_fortran optimizer <span class="textRainbow_lv0_p0">(</span>New Fortran Release 3 or earlier<span class="textRainbow_lv0_p0">)</span> and provides
<span id="L27" class="LineNr"> 27 </span>several new types of optimization, including strength reduction, test
<span id="L28" class="LineNr"> 28 </span>replacement, dead assignment removal, expansion of statement functions
<span id="L29" class="LineNr"> 29 </span>in-line, partial evaluation of logical expressions in logical if
<span id="L30" class="LineNr"> 30 </span>statements, removal of unused assignments, removal of invariant code
<span id="L31" class="LineNr"> 31 </span>from do-loops, and combining of identical sub-expressions.
<span id="L32" class="LineNr"> 32 </span>
<span id="L33" class="LineNr"> 33 </span>
<span id="L34" class="LineNr"> 34 </span>Strength reduction:
<span id="L35" class="LineNr"> 35 </span>A variable that is a simple arithmetic function of the do-loop index
<span id="L36" class="LineNr"> 36 </span>can be calculated as repeated additions instead of a multiplication.
<span id="L37" class="LineNr"> 37 </span>
<span id="L38" class="LineNr"> 38 </span>
<span id="L39" class="LineNr"> 39 </span>Test replacement:
<span id="L40" class="LineNr"> 40 </span>If a do-loop index is not used at all, either within the do-loop or
<span id="L41" class="LineNr"> 41 </span>within the extended range of that do-loop, and there is a variable
<span id="L42" class="LineNr"> 42 </span>within the loop that is a simple arithmetic function of the do-loop
<span id="L43" class="LineNr"> 43 </span>index, then the do-loop end condition test is changed to use that
<span id="L44" class="LineNr"> 44 </span>variable, rather than the do-loop index.
<span id="L45" class="LineNr"> 45 </span>
<span id="L46" class="LineNr"> 46 </span>
<span id="L47" class="LineNr"> 47 </span>Dead assignment removal:
<span id="L48" class="LineNr"> 48 </span>Assignments to do-loop index are not performed if the do-loop index is
<span id="L49" class="LineNr"> 49 </span>not used at all, either within the do-loop or within the extended
<span id="L50" class="LineNr"> 50 </span>range of that do-loop.
<span id="L51" class="LineNr"> 51 </span>
<span id="L52" class="LineNr"> 52 </span>
<span id="L53" class="LineNr"> 53 </span>Removal of invariants:
<span id="L54" class="LineNr"> 54 </span>Expressions that are invariant within a do-loop are moved to the next
<span id="L55" class="LineNr"> 55 </span>higher loop.
<span id="L56" class="LineNr"> 56 </span>
<span id="L57" class="LineNr"> 57 </span>
<span id="L58" class="LineNr"> 58 </span>Partial evaluation of expressions:
<span id="L59" class="LineNr"> 59 </span>Expressions in logical if statements are only evaluated until the
<span id="L60" class="LineNr"> 60 </span>truth value of the expression is completely known.
<span id="L61" class="LineNr"> 61 </span>
<span id="L62" class="LineNr"> 62 </span>
<span id="L63" class="LineNr"> 63 </span>Array subscripting has been vastly improved.
<span id="L64" class="LineNr"> 64 </span>
<span id="L65" class="LineNr"> 65 </span>
<span id="L66" class="LineNr"> 66 </span>Statement function references:
<span id="L67" class="LineNr"> 67 </span>References to statement functions are expanded in-line and are
<span id="L68" class="LineNr"> 68 </span>therefore subject to combined sub-expression optimization.
<span id="L69" class="LineNr"> 69 </span>
<span id="L70" class="LineNr"> 70 </span>
<span id="L71" class="LineNr"> 71 </span>Combining identical sub-expressions:
<span id="L72" class="LineNr"> 72 </span>Whenever the flow of the program allows, identical sub-expressions are
<span id="L73" class="LineNr"> 73 </span>pooled, that is, the expression is calculated once and stored in a
<span id="L74" class="LineNr"> 74 </span>temporary where it can be referenced as needed.
<span id="L75" class="LineNr"> 75 </span>
<span id="L76" class="LineNr"> 76 </span>
<span id="L77" class="LineNr"> 77 </span>Assignment removal:
<span id="L78" class="LineNr"> 78 </span>Useless assignment statements are removed from the code entirely!!!
<span id="L79" class="LineNr"> 79 </span>The two major causes of useless assignments are assignments to a
<span id="L80" class="LineNr"> 80 </span>variable that are immediately followed by another assignment to the
<span id="L81" class="LineNr"> 81 </span>same variable and assignment statements referencing automatic
<span id="L82" class="LineNr"> 82 </span>variables immediately preceding a return statement.  The optimizer
<span id="L83" class="LineNr"> 83 </span>warns the user whenever a block of code is removed.
<span id="L84" class="LineNr"> 84 </span>
<span id="L85" class="LineNr"> 85 </span>
<span id="L86" class="LineNr"> 86 </span>Machine dependant optimizations:
<span id="L87" class="LineNr"> 87 </span>In addition to the machine independant optimizations performed by the
<span id="L88" class="LineNr"> 88 </span>loop optimizer, the -optimize <span class="textRainbow_lv0_p0">(</span>-ot<span class="textRainbow_lv0_p0">)</span> control argument also invokes a
<span id="L89" class="LineNr"> 89 </span>machine dependant global optimizer <span class="textRainbow_lv0_p0">(</span>register optimizer<span class="textRainbow_lv0_p0">)</span> to perform
<span id="L90" class="LineNr"> 90 </span>such optimizations as global register allocation and pulling register
<span id="L91" class="LineNr"> 91 </span>loads out of loops.
<span id="L92" class="LineNr"> 92 </span>
<span id="L93" class="LineNr"> 93 </span>
<span id="L94" class="LineNr"> 94 </span>Pointers to common blocks:
<span id="L95" class="LineNr"> 95 </span>Pointers to frequently used common blocks are loaded into pointer
<span id="L96" class="LineNr"> 96 </span>registers before the loops in which they are frequently used and are
<span id="L97" class="LineNr"> 97 </span>kept loaded throughout these loops.
<span id="L98" class="LineNr"> 98 </span>
<span id="L99" class="LineNr"> 99 </span>
<span id="L100" class="LineNr">100 </span>Invariant index values:
<span id="L101" class="LineNr">101 </span>Loop invariant values used in indexing <span class="textRainbow_lv0_p0">(</span>subscripting<span class="textRainbow_lv0_p0">)</span> are loaded into
<span id="L102" class="LineNr">102 </span>index registers before the loops in which they are invariant and are
<span id="L103" class="LineNr">103 </span>kept loaded throughout these loops.
<span id="L104" class="LineNr">104 </span>
<span id="L105" class="LineNr">105 </span>
<span id="L106" class="LineNr">106 </span>Induction variables:
<span id="L107" class="LineNr">107 </span>Induction variables that are only used for addressing within a loop
<span id="L108" class="LineNr">108 </span>are loaded into index registers before the loop and are incremented in
<span id="L109" class="LineNr">109 </span>the index registers directly.  An induction variable that is globally
<span id="L110" class="LineNr">110 </span>assigned to an index register in this way is not stored within the
<span id="L111" class="LineNr">111 </span>loop unless the loop contains contexts which might erase the register,
<span id="L112" class="LineNr">112 </span>such as a subroutine call, or unless the induction variable's value is
<span id="L113" class="LineNr">113 </span>needed after loop termination or exit.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
